'' 4.3" LCD Driver Demo
'' by Andy Schenk Dec 2009

CON
  _clkmode = xtal1+pll16x
  _clkfreq = 80_000_000

DAT   'LCD connection and settings
sync          long  0           'Sync indicator variable
basepin       long  16          'CUSTOMIZE this Pin settings!!
DEpin         long  24
PCLKpin       long  25
DONpin        long  10
BLpin         long  11
Brightness    long  22          '1..31
parpass       long  0[4]        'reserved for parameter passing 

VAR
  long colors[lcd#COLOR_NUM]
'  word colors[lcd#COLOR_NUM]        'for 2 color modes word size is enough

  long screen[lcd#SCREEN_SIZE/4]

  long rndm, rowsz  

OBJ
  lcd : "TSD_4Color_Bitmap"       'uncomment only one of the drivers
'  lcd : "TSD_LowRes_Bitmap"
'  lcd : "TSD_HiRes_Bitmap"
  
PUB Main  | i,x,y,c
  lcd.start(@colors, @screen, @sync)
  rowsz := lcd#ROW_SIZE/4
  rndm := cnt

  repeat
    repeat 3
      repeat i from 0 to lcd#COLOR_NUM-1       'randmom color tiles
        colors[i] := rndm?
      waitcnt(clkfreq*2 + cnt)
     
    repeat i from 0 to lcd#COLOR_NUM-1         'set same color for all tiles
      if lcd#PIXEL_BITS==2
        colors[i] := %%3300_3030_0300_0010
      else
        colors[i] := %%3300_0010_3300_0010
     
    repeat 5000                                'random pixels
      x := ||rndm? // lcd#PIXEL_WIDTH
      y := ||rndm? // lcd#PIXEL_HEIGHT
      c := rndm? & 3
      plot(x,y,c)
    waitcnt(clkfreq + cnt)

    if rndm? & 1 == 0
      bytefill(@screen, 0, lcd#SCREEN_SIZE)    'clear screen
         
    repeat 3                                   'draw lines
      c := rndm? & 3
      i := rndm? & 3
      repeat x from 0 to lcd#PIXEL_WIDTH-1 step 8
        y := lcd#PIXEL_HEIGHT * (lcd#PIXEL_WIDTH-x) / lcd#PIXEL_WIDTH
        line(x,0, 0,y, c)    
        line(lcd#PIXEL_WIDTH-1-x,lcd#PIXEL_HEIGHT-1, lcd#PIXEL_WIDTH-1,lcd#PIXEL_HEIGHT-1-y, c^i)
     

PUB plot(px,py, color) | bs
  if lcd#PIXEL_BITS == 2
    color &= 3
    bs := (px&15)<<1
    screen[py*rowsz + px>>4] &= !(%11<<bs)      'overwrite mode
    screen[py*rowsz + px>>4] |= color<<bs
'    screen[py*rowsz + px>>4] ^= color<<bs       'xor mode
  else
    color &= 1
    bs := px&31
'    screen[py*rowsz + px>>5] &= !(%11<<bs)      'overwrite mode
'    screen[py*rowsz + px>>5] |= color<<bs
    screen[py*rowsz + px>>5] ^= color<<bs       'xor mode

PUB line(x1,y1, x2,y2, color) |dx,dy,d
  if ||(x2-x1) > ||(y2-y1)
    d := x2-x1
    repeat dx from x1 to x2
      plot(dx, (y2-y1)*(dx-x1)/d+y1, color)
  else
    d := y2-y1
    repeat dy from y1 to y2
      plot((x2-x1)*(dy-y1)/d+x1, dy, color)
      
           